Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QTranslator

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QObject
                  com.trolltech.qt.core.QTranslator

All Implemented Interfaces:
  QtJambiInterface

    public class QTranslator

extends QObject

The `QTranslator` class provides internationalization support for text output. An object of this class contains a set of translations from a source language to a target language. `QTranslator` provides functions to look up translations in a translation file. Translation files are created using Qt Linguist.

The most common use of `QTranslator` is to: load a translation file, install it using `QApplication::installTranslator()`, and use it via QObject::tr(). Here's the `main()` function from the Hello tr() example:
The following code example is written in c++.

    int main(int argc, char *argv[])

    {
        QApplication app(argc, argv);

        QTranslator translator;

        translator.load("hellotr_la");

        app.installTranslator(&translator);

        QPushButton hello(QPushButton::tr("Hello world!"));

        hello.resize(100, 30);

        hello.show();
        return app.exec();
    }

Note that the translator must be created before the application's widgets.

Most applications will never need to do anything else with this class. The other functions provided by this class are useful for applications that work on translator files.

It is possible to lookup a translation using `translate()` (as tr() and `QApplication::translate()` do). The `translate()` function takes up to three parameters:

- The context - usually the class name for the tr() caller.
- The source text - usually the argument to tr().
- The comment - an optional comment that helps disambiguate different uses of the same text in the same context.

For example, the "Cancel" in a dialog might have "Anuluj" when the program runs in Polish (in this case the source text would be "Cancel"). The context would (normally) be the dialog's class name; there would normally be no comment, and the translated text would be "Anuluj".

But it's not always so simple. The Spanish version of a printer dialog with settings for two-sided printing and binding would probably require both "Activado" and "Activada" as translations for "Enabled". In this case the source text would be "Enabled" in both cases, and the context would be the dialog's class name, but the two items would have disambiguating comments such as "two-sided printing" for one and "binding" for the other. The comment enables the translator to choose the appropriate gender for the Spanish version, and enables Qt to distinguish between translations.

See also:
  `QApplication::installTranslator()`, `QApplication::removeTranslator()`, QObject::tr(), `QApplication::translate()`, I18N Example, Hello tr() Example, Arrow Pad Example, and Troll Print Example.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Constructor Summary
`QTranslator()` Constructs an empty message file object with parent `parent` that is not connected to any file.
`QTranslator(QObject parent)` Constructs an empty message file object with parent `parent` that is not connected to any file.

Method Summary
`static QTranslator` | `fromNativePointer(QNativePointer nativePointer)` This method returns the QTranslator instance pointed to by `nativePointer`.
`boolean` | `isEmpty()` Returns true if this translator is empty, otherwise returns false.
`boolean` | `load(byte[] data)` Loads the .qm file data `data` into the translator.
`boolean` | `load(java.lang.String filename)` Loads `filename` + `suffix` (".qm" if the `suffix` is not specified), which may be an absolute file name or relative to `directory`.
`boolean` | `load(java.lang.String filename, java.lang.String directory)` Loads `filename` + `suffix` (".qm" if the `suffix` is not specified), which may be an absolute file name or relative to `directory`.
`boolean` | `load(java.lang.String filename, java.lang.String directory, java.lang.String search_delimiters)` Loads `filename` + `suffix` (".qm" if the `suffix` is not specified), which may be an absolute file name or relative to `directory`.
`boolean` | `load(java.lang.String filename, java.lang.String directory, java.lang.String search_delimiters, java.lang.String suffix)` Loads `filename` + `suffix` (".qm" if the `suffix` is not specified), which may be an absolute file name or relative to `directory`.
`java.lang.String` | `translate(java.lang.String context, java.lang.String sourceText)` Returns the translation for the key (`context`, `sourceText`).
`java.lang.String` | `translate(java.lang.String context, java.lang.String sourceText, java.lang.String comment)` Returns the translation for the key (`context`, `sourceText`, `comment`).

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QTranslator

    public QTranslator()

  Constructs an empty message file object with parent `parent` that is not connected to any file.

### QTranslator

    public QTranslator(QObject parent)

  Constructs an empty message file object with parent `parent` that is not connected to any file.

Method Detail

### load

    public final boolean load(java.lang.String filename,
                              java.lang.String directory,
                              java.lang.String search_delimiters)

  Loads `filename` + `suffix` (".qm" if the `suffix` is not specified), which may be an absolute file name or relative to `directory`. Returns true if the translation is successfully loaded; otherwise returns false.

  The previous contents of this translator object are discarded.

  If the file name does not exist, other file names are tried in the following order:

  1. File name without `suffix` appended.
  2. File name with text after a character in `search_delimiters` stripped ("`_`." is the default for `search_delimiters` if it is an empty string) and `suffix`.
  3. File name stripped without `suffix` appended.
  4. File name stripped further, etc.
  For example, an application running in the `fr_CA` locale (French-speaking Canada) might call load("foo.`fr_ca`", "/opt/foolib"). `load()` would then try to open the first existing readable file from this list:
  1. `/opt/foolib/foo.fr_ca.qm`
  2. `/opt/foolib/foo.fr_ca`
  3. `/opt/foolib/foo.fr.qm`
  4. `/opt/foolib/foo.fr`
  5. `/opt/foolib/foo.qm`
  6. `/opt/foolib/foo`

### load

    public final boolean load(java.lang.String filename,
                              java.lang.String directory)

  Loads `filename` + `suffix` (".qm" if the `suffix` is not specified), which may be an absolute file name or relative to `directory`. Returns true if the translation is successfully loaded; otherwise returns false.

  The previous contents of this translator object are discarded.

  If the file name does not exist, other file names are tried in the following order:

  1. File name without `suffix` appended.
  2. File name with text after a character in `search_delimiters` stripped ("`_`." is the default for `search_delimiters` if it is an empty string) and `suffix`.
  3. File name stripped without `suffix` appended.
  4. File name stripped further, etc.
  For example, an application running in the `fr_CA` locale (French-speaking Canada) might call load("foo.`fr_ca`", "/opt/foolib"). `load()` would then try to open the first existing readable file from this list:
  1. `/opt/foolib/foo.fr_ca.qm`
  2. `/opt/foolib/foo.fr_ca`
  3. `/opt/foolib/foo.fr.qm`
  4. `/opt/foolib/foo.fr`
  5. `/opt/foolib/foo.qm`
  6. `/opt/foolib/foo`

### load

    public final boolean load(java.lang.String filename)

  Loads `filename` + `suffix` (".qm" if the `suffix` is not specified), which may be an absolute file name or relative to `directory`. Returns true if the translation is successfully loaded; otherwise returns false.

  The previous contents of this translator object are discarded.

  If the file name does not exist, other file names are tried in the following order:

  1. File name without `suffix` appended.
  2. File name with text after a character in `search_delimiters` stripped ("`_`." is the default for `search_delimiters` if it is an empty string) and `suffix`.
  3. File name stripped without `suffix` appended.
  4. File name stripped further, etc.
  For example, an application running in the `fr_CA` locale (French-speaking Canada) might call load("foo.`fr_ca`", "/opt/foolib"). `load()` would then try to open the first existing readable file from this list:
  1. `/opt/foolib/foo.fr_ca.qm`
  2. `/opt/foolib/foo.fr_ca`
  3. `/opt/foolib/foo.fr.qm`
  4. `/opt/foolib/foo.fr`
  5. `/opt/foolib/foo.qm`
  6. `/opt/foolib/foo`

### load

    public final boolean load(java.lang.String filename,
                              java.lang.String directory,
                              java.lang.String search_delimiters,
                              java.lang.String suffix)

  Loads `filename` + `suffix` (".qm" if the `suffix` is not specified), which may be an absolute file name or relative to `directory`. Returns true if the translation is successfully loaded; otherwise returns false.

  The previous contents of this translator object are discarded.

  If the file name does not exist, other file names are tried in the following order:

  1. File name without `suffix` appended.
  2. File name with text after a character in `search_delimiters` stripped ("`_`." is the default for `search_delimiters` if it is an empty string) and `suffix`.
  3. File name stripped without `suffix` appended.
  4. File name stripped further, etc.
  For example, an application running in the `fr_CA` locale (French-speaking Canada) might call load("foo.`fr_ca`", "/opt/foolib"). `load()` would then try to open the first existing readable file from this list:
  1. `/opt/foolib/foo.fr_ca.qm`
  2. `/opt/foolib/foo.fr_ca`
  3. `/opt/foolib/foo.fr.qm`
  4. `/opt/foolib/foo.fr`
  5. `/opt/foolib/foo.qm`
  6. `/opt/foolib/foo`

### isEmpty

    public boolean isEmpty()

  Returns true if this translator is empty, otherwise returns false. This function works with stripped and unstripped translation files.

### translate

    public final java.lang.String translate(java.lang.String context,
                                            java.lang.String sourceText)

  Returns the translation for the key (`context`, `sourceText`). If that fails, returns an empty string.

### translate

    public java.lang.String translate(java.lang.String context,
                                      java.lang.String sourceText,
                                      java.lang.String comment)

  Returns the translation for the key (`context`, `sourceText`, `comment`). If none is found, also tries (`context`, `sourceText`, ""). If that still fails, returns an empty string.

### fromNativePointer

    public static QTranslator fromNativePointer(QNativePointer nativePointer)

  This method returns the QTranslator instance pointed to by `nativePointer`.

### load

    public final boolean load(byte[] data)

  Loads the .qm file data `data` into the translator.

  The data is not copied. The caller must be able to guarantee that `data` will not be deleted or modified.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD